// $Id: bootstrap.js 13 2012-03-01 02:03:34Z hhofer69@gmail.com $

"use strict";

const RSC        = "reqpolsync";
const CMN        = "rpsmodules";
const EXTMODULES = [ { rsc: RSC, mod: "reqpolsync"}, { rsc: RSC, mod: "rpsutils"}, 
                     { rsc: RSC, mod: "rpsengine"},  { rsc: RSC, mod: "rpscachedb"},
                     { rsc: CMN, mod: "common/syncutils"},
                     { rsc: CMN, mod: "common/logutils"} ];

function startup(data, reason)
{
  setDefaultPrefs();
  Components.utils.import("chrome://"+RSC+"/content/reqpolsync.jsm");
  RequestPolicySync.startup(data, reason);
}

function shutdown(data, reason)
{
  Components.utils.import("chrome://"+RSC+"/content/reqpolsync.jsm");
  RequestPolicySync.shutdown(data, reason);
  
  EXTMODULES.forEach(function _unload(mod) {
    Components.utils.unload("chrome://"+mod.rsc+"/content/"+mod.mod+".jsm");
  });
}

function install(params, reason) {}

function uninstall(params, reason) {}


const DEFAULT_PREFS = {
  "extensions.reqpolsync.debug":     false,
  "extensions.reqpolsync.immediate": false,
  "extensions.reqpolsync.autobak":   true,
  "extensions.reqpolsync.bakage":    14,
  "extensions.reqpolsync.reqpol":    true,
  "extensions.reqpolsync.version":   "",
  "services.sync.engine.reqpolsync": true,
  "services.sync.prefs.sync.extensions.reqpolsync.immediate": true,
  "services.sync.prefs.sync.extensions.reqpolsync.autobak":   true,
  "services.sync.prefs.sync.extensions.reqpolsync.bakage":    true
};

function setDefaultPrefs() {
  Components.utils.import("resource://gre/modules/Services.jsm");
  let branch = Services.prefs.getDefaultBranch("");
  for (let [key, val] in Iterator(DEFAULT_PREFS)) {
    switch (typeof val) {
      case "boolean": branch.setBoolPref(key, val); break;
      case "number":  branch.setIntPref(key,  val); break;
      case "string":  branch.setCharPref(key, val); break;
    }
  }
}
